function lines=gap_filling(lines)

lines = [lines zeros(size(lines,1),1)];

% How many gap-filling segments to construct for each segment
N = 5;

d = eye(size(lines,1));
for i=1:size(lines,1)
    d(i,i) = inf;
end

for i=1:size(lines,1)-1
    for j=i+1:size(lines,1)
        d(i,j) = mindist(lines(i,1:4), lines(j,1:4));
        if (d(i,j) < 1)
            d(i,j) = inf;
        end
        d(j,i) = d(i,j);
    end
end

for i=1:size(lines,1)
    [a indx] = sort(d(:,i));
    for j=1:min([N length(a)])
        %if (a(j) < 30)
        if (isfinite(a(j)))
            if (i < indx(j))
                lines = [lines; minline(lines(i,1:4), lines(indx(j),1:4)) a(j)];
            else
                lines = [lines; minline(lines(indx(j),1:4), lines(i,1:4)) a(j)];
            end
        end
    end
end

%remove duplicates
i=1;
while (i < size(lines,1))
    if (lines(i,5) > 0)
        j = i+1;
        while (j <= size(lines,1))
            if (lines(i,:) == lines(j,:))
                lines(j,:) = [];
            else
                j = j+1;
            end
        end
    end
    i = i+1;
end

return;

% %%%%%%%%%%%%%%%%%
function d=mindist(line1, line2)

dist(1) = norm(line1(1:2) - line2(1:2));
dist(2) = norm(line1(1:2) - line2(3:4));
dist(3) = norm(line1(3:4) - line2(1:2));
dist(4) = norm(line1(3:4) - line2(3:4));

d=min(dist);

return;

% %%%%%%%%%%%%%%%%
function line=minline(line1, line2)

dist(1) = norm(line1(1:2) - line2(1:2));
dist(2) = norm(line1(1:2) - line2(3:4));
dist(3) = norm(line1(3:4) - line2(1:2));
dist(4) = norm(line1(3:4) - line2(3:4));

[d indx]=min(dist);

switch(indx)
    case 1
        line = [line1(1:2) line2(1:2)];
    case 2
        line = [line1(1:2) line2(3:4)];
    case 3
        line = [line1(3:4) line2(1:2)];
    case 4
        line = [line1(3:4) line2(3:4)];
end

return;

