#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

double PI = 3.1415926535897932;
double MAX_DISTANCE = 30;
double MIN_ANGLE = 0.5; // sin(PI/6)
//int MAX_ENDPOINT = 20;

int dround(double);
double proximity(int[300][300], double, double, double, double);
double distance(double x1, double y1, double x2, double y2);
int minimal(double, double, double, double);
double minimum(double, double, double, double);
int seg_intersect(double, double, double, double, double, double, double, double);
int sign(double);
double angle(double, double, double, double, double, double);
int find_dir(double,double,double,double,double,double);
double quad_area(double,double,double,double,double,double,double,double);
int quads_overlap(double, double, double, double, double, double, double, double, double, double, double, double, double, double, double, double);

vector<double*>* construct_graph(vector<double*> *Ttable, vector<double*> *Ltable, double LAMBDA, int MAX_ENDPOINT) {


   double *dataread1, *dataread2;
   double *dataout;
   vector<double*> *Gtable = new vector<double*>;
   double MAX_W1 = 0, MAX_AREA = 0;


   int M[300][300];
   for (int i=0; i<300; i++) {
      for (int j=0; j<300; j++) {
         M[i][j] = 0;}}
   int Ax,Ay,Bx,By,x,y;
   double m,c;
 
   for (int i=0; i<(int)(Ltable->size()); i++) {
      if ((*Ltable)[i][4] > 0) continue;
      Ax = (int)(*Ltable)[i][0];
      Ay = (int)(*Ltable)[i][1];
      Bx = (int)(*Ltable)[i][2];
      By = (int)(*Ltable)[i][3];
      if (abs(Ax - Bx) > abs(Ay - By)) {
         m = (Ay - By)/(double)(Ax - Bx);
         c = Ay - m*Ax;
         for (x=((Ax<Bx)?Ax:Bx); x<=((Ax>Bx)?Ax:Bx); x++) {
            y = dround(( m*x+c ));
            M[y][x] = 1;
         }
      }
      else {
         if (Ax != Bx) {
            m = (Ay - By)/(double)(Ax - Bx);
            c = Ay - m*Ax;
         }
         for (y=((Ay<By)?Ay:By); y<=((Ay>By)?Ay:By); y++) {
            if (Ax != Bx)
               x = dround(((y-c)/m));
            else
               x = Ax;
            M[y][x] = 1;
         }
      }
   }
/*//DEBUG
   for (int i=0; i<300; i++) {
      for (int j=0; j<300; j++) {
         cout << M[i][j] << " ";}
      cout << endl;}
// */

   // PART 2 - SOLID EDGE CONSTRUCTION //

   for (int i=0; i<(int)(Ttable->size()); i++) {
      dataread1 = (*Ttable)[i];
      dataout = new double[5];
      dataout[0] = 4*i;
      dataout[1] = 4*i + 2;
      dataout[2] = 0; 
      dataout[3] = 0;
      dataout[4] = 1; // solid
      (*Gtable).push_back(dataout);

      dataout = new double[5];
      dataout[0] = 4*i + 1;
      dataout[1] = 4*i + 3;
      dataout[2] = 0; 
      dataout[3] = 0; 
      dataout[4] = 1; // solid
      (*Gtable).push_back(dataout);
   }

   //////////////////////////////////////

   // PART 3 - DASHED EDGE CONSTRUCTION //

   double P1[2], back1[2], P2[2], back2[2];
   double L1[2], R1[2], L2[2], R2[2], c1[2], c2[2], cc1[2], cc2[2];
   double D, w1, w2, alpha, beta, gamma, delta, area;
   int k, n1, n2, flag, flag2, count_quads = 0;;

   for (int i=0; i<(int)(Ttable->size()-1); i++) {
      dataread1 = (*Ttable)[i];

      for (int j=i+1; j<(int)(Ttable->size()); j++) {
         dataread2 = (*Ttable)[j];

         // find closest axis endpoints.
         D = minimum(distance(dataread1[0],dataread1[1],dataread2[0],dataread2[1]),distance(dataread1[0],dataread1[1],dataread2[2],dataread2[3]),distance(dataread1[2],dataread1[3],dataread2[0],dataread2[1]),distance(dataread1[2],dataread1[3],dataread2[2],dataread2[3]));
         k = minimal(distance(dataread1[0],dataread1[1],dataread2[0],dataread2[1]),distance(dataread1[0],dataread1[1],dataread2[2],dataread2[3]),distance(dataread1[2],dataread1[3],dataread2[0],dataread2[1]),distance(dataread1[2],dataread1[3],dataread2[2],dataread2[3]));
         // D is min distance, and k is index 1-4, e.g. 1 means O_2i and O_2j
         if (D > MAX_DISTANCE) continue;


         if (k < 3) {
            n1 = 2*i;
            P1[0] = dataread1[0];
            P1[1] = dataread1[1];
            back1[0] = dataread1[2];
            back1[1] = dataread1[3];
            L1[0] = dataread1[4];
            L1[1] = dataread1[5];
            R1[0] = dataread1[6];
            R1[1] = dataread1[7];
            c1[0] = dataread1[8];
            c1[1] = dataread1[9];
            cc1[0] = dataread1[10];
            cc1[1] = dataread1[11];
            // trapezoid is L1R1cc1c1, and is counter-clockwise
         } else {
            n1 = 2*i + 1;
            P1[0] = dataread1[2];
            P1[1] = dataread1[3];
            back1[0] = dataread1[0];
            back1[1] = dataread1[1];
            L1[0] = dataread1[10];
            L1[1] = dataread1[11];
            R1[0] = dataread1[8];
            R1[1] = dataread1[9];
            c1[0] = dataread1[6];
            c1[1] = dataread1[7];
            cc1[0] = dataread1[4];
            cc1[1] = dataread1[5];
            // trapezoid is L1R1cc1c1, and is counter-clockwise
         }

         if (k % 2 == 1) {
            n2 = 2*j;
            P2[0] = dataread2[0];
            P2[1] = dataread2[1];
            back2[0] = dataread2[2];
            back2[1] = dataread2[3];
            L2[0] = dataread2[4];
            L2[1] = dataread2[5];
            R2[0] = dataread2[6];
            R2[1] = dataread2[7];
            c2[0] = dataread2[8];
            c2[1] = dataread2[9];
            cc2[0] = dataread2[10];
            cc2[1] = dataread2[11];
            // trapezoid is L2R2cc2c2, and is counter-clockwise
         } else {
            n2 = 2*j + 1;
            P2[0] = dataread2[2];
            P2[1] = dataread2[3];
            back2[0] = dataread2[0];
            back2[1] = dataread2[1];
            L2[0] = dataread2[10];
            L2[1] = dataread2[11];
            R2[0] = dataread2[8];
            R2[1] = dataread2[9];
            c2[0] = dataread2[6];
            c2[1] = dataread2[7];
            cc2[0] = dataread2[4];
            cc2[1] = dataread2[5];
            // trapezoid is L2R2cc2c2, and is counter-clockwise
         }

         /*alpha = angle(back1[0], back1[1], P1[0], P1[1], P2[0], P2[1]);
         if (fabs(sin(alpha)) > MIN_ANGLE) continue;
         beta = angle(P1[0], P1[1], P2[0], P2[1], back2[0], back2[1]);
         if (fabs(sin(beta)) > MIN_ANGLE) continue;*/
         gamma = angle(back1[0], back1[1], P1[0], P1[1], back2[0], back2[1]);
         if (fabs(sin(gamma)) > MIN_ANGLE) continue;
         delta = angle(back1[0], back1[1], P2[0], P2[1], back2[0], back2[1]);
         if (fabs(sin(delta)) > MIN_ANGLE) continue;



         if (dataread1[12] == dataread2[12] || dataread1[12] == dataread2[13] || dataread1[13] == dataread2[12] || dataread1[13] == dataread2[13]) {
            //here, make sure there is no overlap.
            if (quads_overlap(L1[0],L1[1],R1[0],R1[1],cc1[0],cc1[1],c1[0],c1[1],L2[0],L2[1],R2[0],R2[1],cc2[0],cc2[1],c2[0],c2[1]) == 1) {
               continue;
            }
         }



         //////////////////////////////////////////////////////////////////////////
         // here change to use the direction of back1P1 and P2back2 to determine //
         // the type of connection instead of checking intersections.            //
         //////////////////////////////////////////////////////////////////////////

         flag2 = 0;
         // check connections  between L1R2 and R1L2
         flag = seg_intersect(L1[0], L1[1], L2[0], L2[1], R1[0], R1[1], R2[0], R2[1]);
         if (flag == 1) flag2 = 1;
         // the quad is self-intersecting
         flag = seg_intersect(L1[0], L1[1], R2[0], R2[1], R1[0], R1[1], L2[0], L2[1]);
         if (flag == 1) flag2 += 2;

         if (flag2 == 3) continue;
         
         if (flag2 == 0) {
            flag = seg_intersect(L1[0], L1[1], L2[0], L2[1], cc2[0], cc2[1], R2[0], R2[1]);
            if (flag == 1) flag2 = 1; // the quad is self-intersecting
            flag = seg_intersect(L1[0], L1[1], L2[0], L2[1], R1[0], R1[1], cc1[0], cc1[1]);
            if (flag == 1) flag2 = 1; // the quad is self-intersecting
            flag = seg_intersect(L1[0], L1[1], c1[0], c1[1], R1[0], R1[1], R2[0], R2[1]);
            if (flag == 1) flag2 = 1; // the quad is self-intersecting
            flag = seg_intersect(c2[0], c2[1], L2[0], L2[1], R1[0], R1[1], R2[0], R2[1]);
            if (flag == 1) flag2 = 1; // the quad is self-intersecting
         }

         if ((flag2 % 2) == 0) {
            w1 = proximity(M,L1[0],L1[1],L2[0],L2[1]) + proximity(M,R1[0],R1[1],R2[0],R2[1]);
            if (w1 > (MAX_DISTANCE)) continue;
            w1 += LAMBDA*(fabs(sin(gamma)) + fabs(sin(delta)));
            w1 += (dataread1[15] + dataread2[15])/2;

         } else {
            w1 = proximity(M,L1[0],L1[1],R2[0],R2[1]) + proximity(M,R1[0],R1[1],L2[0],L2[1]);
            if (w1 > (MAX_DISTANCE)) continue;
            w1 += LAMBDA*(fabs(sin(gamma)) + fabs(sin(delta)));
            w1 += (dataread1[15] + dataread2[15])/2;
         }
         
         // quadrilateral is R1L1R2L2
         if ((flag2 % 2) == 0)
            area = quad_area(R1[0],R1[1],L1[0],L1[1],L2[0],L2[1],R2[0],R2[1]);
         else
            area = quad_area(R1[0],R1[1],L1[0],L1[1],R2[0],R2[1],L2[0],L2[1]);


         // create dashed edge
         dataout = new double[5];
         dataout[0] = 2*n1;
         if ((flag2%2) == 0) {
            dataout[1] = 2*n2+1;
            dataout[2] = area + (dataread1[14] - dataread2[14])/2;
         } else {
            dataout[1] = 2*n2;
            dataout[2] = area + (dataread1[14] + dataread2[14])/2;
         }
         dataout[3] = w1;
         dataout[4] = 0; // dashed
         (*Gtable).push_back(dataout);
         // create its inverse
         dataout = new double[5];
         dataout[0] = 2*n1+1;
         if ((flag2%2) == 0) {
               dataout[1] = 2*n2;
               dataout[2] = -area + (-dataread1[14] + dataread2[14])/2;
         } else {
               dataout[1] = 2*n2+1;
               dataout[2] = -area + (-dataread1[14] - dataread2[14])/2;
         }
         dataout[3] = w1;
         dataout[4] = 0; // dashed
         (*Gtable).push_back(dataout);


         count_quads += 2;
         if (w1 > MAX_W1) MAX_W1 = w1;
         if (fabs(dataout[2]) > MAX_AREA) MAX_AREA = fabs(dataout[2]);
         
      }
   }
   cout << "Quadrilaterals: " << count_quads << endl;


   ///////////////////////////////////////

   // PART 4 - AUXILIARY EDGE CONSTRUCTION //

   double d1a, d1b, d2a, d2b;
   int count_ends = 0, count_aux = 0, ends1, ends2;
   for (int i=0; i<(int)(Ttable->size())-1; i++) {
      dataread1 = (*Ttable)[i];
      if (dataread1[15] > 0) continue;

      d1a = proximity(M,dataread1[4],dataread1[5],dataread1[6],dataread1[7]);
      d1b = proximity(M,dataread1[8],dataread1[9],dataread1[10],dataread1[11]);
      ends1 = 0;

      if (d1a <= MAX_ENDPOINT) {
         if (d1a < d1b){
            ends1 = 1;
            w1 = d1a;
         } else {
            ends1 = 2;
            w1 = d1b;
         }
      }
      else if (d1b <= MAX_ENDPOINT) {
         ends1 = 2;
         //w1 = d1b;
      }

      if (ends1 == 0) continue;  
      count_ends++;

      for (int j=i+1; j<(int)(Ttable->size()); j++) {
         dataread2 = (*Ttable)[j];
         if (dataread2[15] > 0) continue;

         d2a = proximity(M,dataread2[4],dataread2[5],dataread2[6],dataread2[7]);
         d2b = proximity(M,dataread2[8],dataread2[9],dataread2[10],dataread2[11]);
         ends2 = 0;

         if (d2a <= MAX_ENDPOINT) {
            if (d2a < d2b) {
               ends2 = 1;
               w2 = d2a;
            } else {
               ends2 = 2;
               w2 = d2b;
            }
         }
         else if (d2b <= MAX_ENDPOINT) {
            ends2 = 2;
            //w2 = d2b;
         }


         if (ends2 == 0) continue;

         if ( (ends1 % 2 == 1) && (ends2 % 2 == 1) ) {
            n1 = 4*i;
            n2 = 4*j;
            

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2;
            dataout[2] = (dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2+1;
            dataout[2] = (dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2;
            dataout[2] = (-dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2+1;
            dataout[2] = (-dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);
         } 
         if ( (ends1 % 2 == 1) && (ends2 > 1) ) {
            n1 = 4*i;
            n2 = 4*j+2;

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2;
            dataout[2] = (dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2+1;
            dataout[2] = (dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2;
            dataout[2] = (-dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2+1;
            dataout[2] = (-dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);
         } 
         if ( (ends1 > 1) && (ends2 % 2 == 1) ) {
            n1 = 4*i+2;
            n2 = 4*j;

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2;
            dataout[2] = (dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2+1;
            dataout[2] = (dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2;
            dataout[2] = (-dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2+1;
            dataout[2] = (-dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);
         } 
         if ( (ends1 > 1) && (ends2 > 1) ) {
            n1 = 4*i+2;
            n2 = 4*j+2;

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2;
            dataout[2] = (dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1;
            dataout[1] = n2+1;
            dataout[2] = (dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2;
            dataout[2] = (-dataread1[14]+dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);

            dataout = new double[5];
            dataout[0] = n1+1;
            dataout[1] = n2+1;
            dataout[2] = (-dataread1[14]-dataread2[14])/2; //0;
            dataout[3] = w1+w2;
            dataout[4] = 2; // aux.
            (*Gtable).push_back(dataout);
         } 
         count_aux += 4;

      }
   }    
cout << "Endpoints: " << count_ends << endl;
cout << "Aux. edges: " << count_aux << endl;
   //////////////////////////////////////////

   //write output
   /*ofstream out("graph.w");
   vector<double*>::iterator itr;
   out << 4*Ttable.size() << " " << (*Gtable).size() << endl;
   for (itr = (*Gtable).begin(); itr != (*Gtable).end(); itr++) {
      dataout = *(itr);
      for (int k=0; k<5; k++)
          if (k == 2)
             out << (int)(dataout[k]*600.0/MAX_AREA) << " ";
          else {if (k == 3)
             out << (int)(dataout[k]*600.0/MAX_W1) << " ";
          else
             out << (int)dataout[k] << " ";}
      out << endl;
   }
   out.close();*/

   dataout = new double[5];
   dataout[0] = MAX_AREA;
   dataout[1] = MAX_W1;
   dataout[2] = 0;
   dataout[3] = 0;
   dataout[4] = 1;
   (*Gtable).push_back(dataout);

   cout << "MAX_AREA: " << MAX_AREA << ", MAX_W1:" << MAX_W1 << endl;


   return Gtable;
}


/*double distance(double x1, double y1, double x2, double y2) {
   return sqrt( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) );
}*/

int minimal(double d1, double d2, double d3, double d4) {
   if (d1 <= d2 && d1 <= d3 && d1 <= d4){return 1;}
   if (d2 <= d1 && d2 <= d3 && d2 <= d4){return 2;}
   if (d3 <= d1 && d3 <= d2 && d3 <= d4){return 3;}
   if (d4 <= d1 && d4 <= d2 && d4 <= d3){return 4;}
   return 0;
}

double minimum(double d1, double d2, double d3, double d4) {
   if (d1 <= d2 && d1 <= d3 && d1 <= d4){return d1;}
   if (d2 <= d1 && d2 <= d3 && d2 <= d4){return d2;}
   if (d3 <= d1 && d3 <= d2 && d3 <= d4){return d3;}
   if (d4 <= d1 && d4 <= d2 && d4 <= d3){return d4;}
   return 0;
}

/*int sign(double d) {
   if (d == 0) return 0;
   return ((d>0)?1:-1);
}

int find_dir(double Ax, double Ay, double Bx, double By, double Cx, double Cy) {

   return (sign((Bx-Ax)*(Cy-Ay) - (Cx-Ax)*(By-Ay)));

}*/

double angle(double p1x, double p1y, double p2x, double p2y, double p3x, double p3y){
   double p1,p2, value;

   p1 = (p3x-p2x)*(p1x-p2x) + (p3y-p2y)*(p1y-p2y);
   p2 = (p3x-p2x)*(p1y-p2y) - (p3y-p2y)*(p1x-p2x);

   if (p1 == 0 && p2 == 0) return 0;

   value = atan2(p2,p1);

   return value;
}

double quad_area(double Ax, double Ay, double Bx, double By, double Cx, double Cy, double Dx, double Dy) {

      double area1 = (-Bx*Ay + Cx*Ay + Ax*By - Cx*By - Ax*Cy + Bx*Cy)/2;
      double area2 = (-Dx*Cy + Ax*Cy + Cx*Dy - Ax*Dy - Cx*Ay + Dx*Ay)/2;

      return (area1+area2);

}

int dround(double d) {
   return ((int)floor(d + 0.5));
}

double proximity(int M[300][300], double Ax, double Ay, double Bx, double By){

   double d=1, m, c, cc, theta, move1, move2, sx, sy, ex, ey, L;
   int x,y, xx, yy;
   
   L = distance(Ax,Ay,Bx,By);
   if ( ((int)Ax)==((int)Bx) && ((int)Ay)==((int)By)) return L;


   if (fabs(Ax-Bx) > fabs(Ay-By)) {
      m = (Ay - By)/(Ax - Bx);
      c = Ay - m*Ax;
      if (m != 0) theta = atan(-1/m);
      else theta = PI/2;
      move1 = cos(theta);
      move2 = sin(theta);
      for (x=dround((Ax<Bx)?Ax:Bx); x<=dround((Ax>Bx)?Ax:Bx); x++) {
         y = dround(( m*x+c ));
         sx = x + d*move1;
         sy = y + d*move2;
         ex = x - d*move1;
         ey = y - d*move2;
         if (fabs(sx-ex) > fabs(sy-ey)) {
            cc = y + x/m;
            for (xx=dround((sx<ex)?sx:ex); xx<=dround((sx>ex)?sx:ex); xx++){
               yy = dround(-(1/m)*xx+cc);
               if (yy < 1 || xx < 1 || yy > 248 || xx > 248) continue;
               if (M[yy][xx] == 1){
                  L = L-1; break;}
            }
         } else {
            if (m != 0) cc = y + x/m;
            for (yy=dround((sy<ey)?sy:ey); yy<=dround((sy>ey)?sy:ey); yy++){
                if (m != 0) xx = dround(m*(cc-yy));
                else xx = x;
                if (yy < 1 || xx < 1 || yy > 248 || xx > 248) continue;
                if (M[yy][xx] == 1){
                   L = L-1; break;}
            }
         }
               
      }
   } else if (fabs(Ay-By) > fabs(Ax-Bx)) {
      if (Ax != Bx) {
         m = (Ay - By)/(Ax - Bx);
         c = Ay - m*Ax;
         theta = atan(-1/m);
      } else theta = 0;
      move1 = cos(theta);
      move2 = sin(theta);
      for (y=dround((Ay<By)?Ay:By); y<=dround((Ay>By)?Ay:By); y++) {
         if (Ax != Bx)
            x = dround(((y-c)/m));
         else
            x = dround(Ax);
         sx = x + d*move1;
         sy = y + d*move2;
         ex = x - d*move1;
         ey = y - d*move2;
         if (fabs(sx-ex) > fabs(sy-ey)) {
            cc = y + x/m;
            for (xx=dround((sx<ex)?sx:ex); xx<=dround((sx>ex)?sx:ex); xx++){
               if (sy != ey) yy = dround(-(1/m)*xx+cc);
               else yy = dround(sy);
               if (yy < 1 || xx < 1 || yy > 248 || xx > 248) continue;
               if (M[yy][xx] == 1){
                  L = L-1; break;}
            }
         } else {
            if (m != 0) cc = y + x/m;
            for (yy=dround((sy<ey)?sy:ey); yy<=dround((sy>ey)?sy:ey); yy++){
                if (m != 0) xx = dround(m*(cc-yy));
                else xx = x;
                if (yy < 1 || xx < 1 || yy > 248 || xx > 248) continue;
                if (M[yy][xx] == 1){
                   L = L-1; break;}
            }
         }

      }

   }

   else {
      // we do 4 neighbors check for each (x,y)
      m = (Ay - By)/(Ax - Bx);
      c = Ay - m*Ax;
      for (x=dround((Ax<Bx)?Ax:Bx); x<=dround((Ax>Bx)?Ax:Bx); x++) {
         y = dround(( m*x+c ));
         if (y < 1 || x < 1 || y > 248 || x > 248) continue;
         if ( (M[y][x] + M[y-1][x] + M[y+1][x] + M[y][x+1] + M[y][x-1]) > 0)
            L--;
      }
   }


   if (L<0) L=0;

   return L;

}

/*int seg_intersect(double Ax, double Ay, double Bx, double By, double Cx, double Cy, double Dx, double Dy){
   double test1, test2;

   test1 = ((Ay-Cy)*(Dx-Cx) - (Dy-Cy)*(Ax-Cx))*((By-Cy)*(Dx-Cx) - (Dy-Cy)*(Bx-Cx));
   test2 = ((Cy-Ay)*(Bx-Ax) - (By-Ay)*(Cx-Ax))*((Dy-Ay)*(Bx-Ax) - (By-Ay)*(Dx-Ax));
   if (test1 <= 0 && test2 <= 0) return 1;
   else return 0;
    
}*/


int quads_overlap(double Ax, double Ay, double Bx, double By, double Cx, double Cy, double Dx, double Dy, double AAx, double AAy, double BBx, double BBy, double CCx, double CCy, double DDx, double DDy) {
   // check if quadrilaterals ABCD and AABBCCDD overlap or not
   // this is done by verifying if any of their sides intersect

   if (seg_intersect(Ax,Ay,Bx,By,AAx,AAy,BBx,BBy) == 1) return 1;
   if (seg_intersect(Ax,Ay,Bx,By,BBx,BBy,CCx,CCy) == 1) return 1;
   if (seg_intersect(Ax,Ay,Bx,By,CCx,CCy,DDx,DDy) == 1) return 1;
   if (seg_intersect(Ax,Ay,Bx,By,DDx,DDy,AAx,AAy) == 1) return 1;

   if (seg_intersect(Bx,By,Cx,Cy,AAx,AAy,BBx,BBy) == 1) return 1;
   if (seg_intersect(Bx,By,Cx,Cy,BBx,BBy,CCx,CCy) == 1) return 1;
   if (seg_intersect(Bx,By,Cx,Cy,CCx,CCy,DDx,DDy) == 1) return 1;
   if (seg_intersect(Bx,By,Cx,Cy,DDx,DDy,AAx,AAy) == 1) return 1;

   if (seg_intersect(Cx,Cy,Dx,Dy,AAx,AAy,BBx,BBy) == 1) return 1;
   if (seg_intersect(Cx,Cy,Dx,Dy,BBx,BBy,CCx,CCy) == 1) return 1;
   if (seg_intersect(Cx,Cy,Dx,Dy,CCx,CCy,DDx,DDy) == 1) return 1;
   if (seg_intersect(Cx,Cy,Dx,Dy,DDx,DDy,AAx,AAy) == 1) return 1;

   if (seg_intersect(Dx,Dy,Ax,Ay,AAx,AAy,BBx,BBy) == 1) return 1;
   if (seg_intersect(Dx,Dy,Ax,Ay,BBx,BBy,CCx,CCy) == 1) return 1;
   if (seg_intersect(Dx,Dy,Ax,Ay,CCx,CCy,DDx,DDy) == 1) return 1;
   if (seg_intersect(Dx,Dy,Ax,Ay,DDx,DDy,AAx,AAy) == 1) return 1;

   return 0;

}

